'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TextCell = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _OverflowExpander = require('./OverflowExpander');

var _OverflowExpander2 = _interopRequireDefault(_OverflowExpander);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var HORZ_PADDING = 6;

var TextCell = exports.TextCell = function TextCell(props) {
  var content = void 0;

  if (props.cellData.type === 'TEXT') {
    if (!props.cellData.main) {
      content = '';
    } else {
      content = props.cellData.main.text;
      var href = props.cellData.main.href;
      if (href) {
        content = _react2.default.createElement(
          'a',
          { href: href, target: '_blank' },
          content
        );
      }
    }
  } else {
    content = props.cellData.text || props.cellData.main || '';
    content = (typeof content === 'undefined' ? 'undefined' : _typeof(content)) === 'object' ? JSON.stringify(content) : content;
  }

  return _react2.default.createElement(
    'div',
    {
      className: 'text-cell',
      style: {
        float: 'left',
        padding: '0 ' + HORZ_PADDING + 'px'
      }
    },
    _react2.default.createElement(
      _OverflowExpander2.default,
      { availableWidth: props.width - HORZ_PADDING * 2 },
      content
    )
  );
};

TextCell.propTypes = {
  cellData: _react2.default.PropTypes.object.isRequired,
  width: _react2.default.PropTypes.number.isRequired
};