'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UrlCell = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _OverflowExpander = require('./OverflowExpander');

var _OverflowExpander2 = _interopRequireDefault(_OverflowExpander);

var _constants = require('./constants');

var Constants = _interopRequireWildcard(_constants);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var HORZ_PADDING = 5;
if (Constants.CELL_EXPANDER_SAMELINE) {
  HORZ_PADDING = 5;
}

var UrlCell = exports.UrlCell = function UrlCell(props) {
  var content = props.cellData.text || props.cellData.main;
  content = (typeof content === 'undefined' ? 'undefined' : _typeof(content)) === 'object' ? JSON.stringify(content) : content;

  return _react2.default.createElement(
    'div',
    {
      className: 'url-cell',
      style: {
        float: 'left',
        padding: '0 ' + HORZ_PADDING + 'px'
      }
    },
    _react2.default.createElement(
      'a',
      {
        className: 'url-cell-content',
        href: props.cellData.main,
        title: props.cellData.title || props.cellData.text || props.cellData.main,
        target: '_blank',
        style: {
          display: 'inline-block'
        }
      },
      _react2.default.createElement(
        _OverflowExpander2.default,
        { availableWidth: props.width - HORZ_PADDING * 2 },
        content
      )
    )
  );
};

UrlCell.propTypes = {
  cellData: _react2.default.PropTypes.object.isRequired,
  width: _react2.default.PropTypes.number.isRequired
};